gphoto2-filesys.c File Reference
`#include "config.h"`
`#include <gphoto2/gphoto2-filesys.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include <stdio.h>`
`#include <gphoto2/gphoto2-result.h>`
`#include <gphoto2/gphoto2-port-log.h>`
`#include <gphoto2/gphoto2-setting.h>`
`#include <limits.h>`
`#include "libgphoto2/i18n.h"`
Include dependency graph for gphoto2-filesys.c:

## Data Structures

struct | _CameraFilesystemFile
struct | _CameraFilesystemFolder
struct | _CameraFilesystem
| The internal camera filesystem structure. More...

## Macros

#define | _DEFAULT_SOURCE
#define | PATH_MAX 4096
#define | PICTURES_TO_KEEP 2
#define | MIN(a, b) (((a) < (b)) ? (a) : (b))
#define | CR(result) {int __r = (result); if (__r < 0) return (__r);}
#define | CL(result, list)
#define | CU(result, file)
#define | CC(context)
#define | CA(f, c)

## Typedefs

typedef struct _CameraFilesystemFile | CameraFilesystemFile
typedef struct _CameraFilesystemFolder | CameraFilesystemFolder

## Functions

int | gp_filesystem_reset (CameraFilesystem *fs)
| Clear the filesystem. More...
int | gp_filesystem_new (CameraFilesystem **fs)
| Create a new filesystem struct. More...
int | gp_filesystem_free (CameraFilesystem *fs)
| Free filesystem struct. More...
int | gp_filesystem_append (CameraFilesystem *fs, const char *folder, const char *filename, GPContext *context)
int | gp_filesystem_dump (CameraFilesystem *fs)
| Dump the current filesystem. More...
int | gp_filesystem_delete_all (CameraFilesystem *fs, const char *folder, GPContext *context)
| Delete all files in specified folder. More...
int | gp_filesystem_list_files (CameraFilesystem *fs, const char *folder, CameraList *list, GPContext *context)
| Get the list of files in a folder. More...
int | gp_filesystem_list_folders (CameraFilesystem *fs, const char *folder, CameraList *list, GPContext *context)
| List all subfolders within a filesystem folder. More...
int | gp_filesystem_count (CameraFilesystem *fs, const char *folder, GPContext *context)
| Count files a folder of a filesystem. More...
int | gp_filesystem_delete_file (CameraFilesystem *fs, const char *folder, const char *filename, GPContext *context)
| Delete a file from a folder. More...
int | gp_filesystem_delete_file_noop (CameraFilesystem *fs, const char *folder, const char *filename, GPContext *context)
| Delete a virtal file from a folder in the filesystem. More...
int | gp_filesystem_make_dir (CameraFilesystem *fs, const char *folder, const char *name, GPContext *context)
| Create a subfolder within a folder. More...
int | gp_filesystem_remove_dir (CameraFilesystem *fs, const char *folder, const char *name, GPContext *context)
| Remove a subfolder from within a folder. More...
int | gp_filesystem_put_file (CameraFilesystem *fs, const char *folder, const char *filename, CameraFileType type, CameraFile *file, GPContext *context)
| Upload a file to a folder on the device filesystem. More...
int | gp_filesystem_name (CameraFilesystem *fs, const char *folder, int filenumber, const char **filename, GPContext *context)
| Lookup the filename of an indexed file within a folder. More...
int | gp_filesystem_number (CameraFilesystem *fs, const char *folder, const char *filename, GPContext *context)
| Get the index of a file in specified folder. More...
int | gp_filesystem_get_folder (CameraFilesystem *fs, const char *filename, char **folder, GPContext *context)
| Search a folder that contains a given filename. More...
int | gp_filesystem_get_file (CameraFilesystem *fs, const char *folder, const char *filename, CameraFileType type, CameraFile *file, GPContext *context)
| Get file data from the filesystem. More...
int | gp_filesystem_read_file (CameraFilesystem *fs, const char *folder, const char *filename, CameraFileType type, uint64_t offset, char *buf, uint64_t *size, GPContext *context)
| Get partial file data from the filesystem. More...
int | gp_filesystem_set_funcs (CameraFilesystem *fs, CameraFilesystemFuncs *funcs, void *data)
| Set all filesystem related function pointers. More...
int | gp_filesystem_get_info (CameraFilesystem *fs, const char *folder, const char *filename, CameraFileInfo *info, GPContext *context)
| Get information about the specified file. More...
int | gp_filesystem_set_file_noop (CameraFilesystem *fs, const char *folder, const char *filename, CameraFileType type, CameraFile *file, GPContext *context)
| Attach file content to a specified file. More...
int | gp_filesystem_set_info_noop (CameraFilesystem *fs, const char *folder, const char *filename, CameraFileInfo info, GPContext *context)
| Store the file information in the virtual fs. More...
int | gp_filesystem_set_info_dirty (CameraFilesystem *fs, const char *folder, const char *filename, GPContext *context)
| Mark the file info as dirty. More...
int | gp_filesystem_set_info (CameraFilesystem *fs, const char *folder, const char *filename, CameraFileInfo info, GPContext *context)
| Set information about a file. More...
int | gp_filesystem_get_storageinfo (CameraFilesystem *fs, CameraStorageInformation **storageinfo, int *nrofstorageinfos, GPContext *context)
| Get the storage information about this filesystem. More...

## Detailed Description

Author
  Copyright 2000 Scott Fritzinger
  Contributions Lutz Mueller lutz@.nosp@m.user.nosp@m.s.sf..nosp@m.net (2001)
  Copyright 2009 Marcus Meissner

License
  This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License along with this library; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

## Macro Definition Documentation

## CA

#define CA | ( |  | f,
|  |  | c
| ) |  |

Value:
{ \
if ((f)[0] != '/') { \
gp_context_error ((c), \
_("The path '%s' is not absolute."), (f)); \
return (GP_ERROR_PATH_NOT_ABSOLUTE); \
} \
}
GP_ERROR_PATH_NOT_ABSOLUTE
#define GP_ERROR_PATH_NOT_ABSOLUTE
Path is not absolute.
Definition: gphoto2-result.h:99

## CC

#define CC | ( |  | context | ) |

Value:
{ \
if (gp_context_cancel (context) == GP_CONTEXT_FEEDBACK_CANCEL) \
return GP_ERROR_CANCEL; \
}
gp_context_cancel
GPContextFeedback gp_context_cancel(GPContext *context)
Definition: gphoto2-context.c:323
GP_CONTEXT_FEEDBACK_CANCEL
@ GP_CONTEXT_FEEDBACK_CANCEL
Definition: gphoto2-context.h:57
GP_ERROR_CANCEL
#define GP_ERROR_CANCEL
Cancellation successful.
Definition: gphoto2-result.h:107

## CL

#define CL | ( |  | result,
|  |  | list
| ) |  |

Value:
{ \
int __r = (result); \
\
if (__r < 0) { \
gp_list_free (list); \
return (__r); \
} \
}

## CU

#define CU | ( |  | result,
|  |  | file
| ) |  |

Value:
{ \
int __r = (result); \
\
if (__r < 0) { \
gp_file_unref (file); \
return (__r); \
} \
}

## PICTURES_TO_KEEP

#define PICTURES_TO_KEEP 2

The default number of pictures to keep in the internal cache, can be overridden by settings.

## Function Documentation

## gp_filesystem_count()

int gp_filesystem_count | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | GPContext * | context
| ) |  |

Count files a folder of a filesystem.

Parameters

  fs | a CameraFilesystem
  folder | a folder in which to count the files
  context | a GPContext

Counts the files in the folder.

Returns
  The number of files in the folder or a gphoto2 error code.

## gp_filesystem_delete_all()

int gp_filesystem_delete_all | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | GPContext * | context
| ) |  |

Delete all files in specified folder.

Parameters

  fs | a CameraFilesystem
  folder | the folder in which to delete all files
  context | a GPContext

Deletes all files in the given folder from the fs. If the fs has not been supplied with a delete_all_func, it tries to delete the files one by one using the delete_file_func. If that function has not been supplied neither, an error is returned.

Returns
  a gphoto2 error code.

## gp_filesystem_delete_file()

int gp_filesystem_delete_file | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | filename,
|  | GPContext * | context
| ) |  |

Delete a file from a folder.

Parameters

  fs | a CameraFilesystem
  folder | a folder in which to delete the file
  filename | the name of the file to delete
  context | a GPContext

If a delete_file_func has been supplied to the fs, this function will be called and, if this function returns without error, the file will be removed from the fs.

Returns
  a gphoto2 error code.

## gp_filesystem_delete_file_noop()

int gp_filesystem_delete_file_noop | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | filename,
|  | GPContext * | context
| ) |  |

Delete a virtal file from a folder in the filesystem.

Parameters

  fs | a CameraFilesystem
  folder | a folder in which to delete the file
  filename | the name of the file to delete
  context | a GPContext

Remove a file from the filesystem. Compared to gp_filesystem_delete_file() this just removes the file from the libgphoto2 view of the filesystem, but does not call the camera driver to delete it from the physical device.

Returns
  a gphoto2 error code.

## gp_filesystem_dump()

int gp_filesystem_dump | ( | CameraFilesystem * | fs | ) |

Dump the current filesystem.

Parameters

  fs | the CameraFilesystem

Returns
  a gphoto error code

Internal function to dump the current filesystem.

## gp_filesystem_free()

int gp_filesystem_free | ( | CameraFilesystem * | fs | ) |

Free filesystem struct.

Parameters

  fs | a CameraFilesystem

Frees the CameraFilesystem

Returns
  a gphoto2 error code.

References gp_filesystem_reset(), and GP_OK.

Referenced by gp_camera_free().

## gp_filesystem_get_file()

int gp_filesystem_get_file | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | filename,
|  | CameraFileType | type,
|  | CameraFile * | file,
|  | GPContext * | context
| ) |  |

Get file data from the filesystem.

Parameters

  fs | a CameraFilesystem
  folder | the folder in which the file can be found
  filename | the name of the file to download
  type | the type of the file
  file | the file that receives the data
  context | a GPContext

Downloads the file called filename from the folder using the get_file_func if such a function has been previously supplied. If the file has been previously downloaded, the file is retrieved from cache. The result is stored in the passed file structure.

Returns
  a gphoto2 error code.

## gp_filesystem_get_folder()

int gp_filesystem_get_folder | ( | CameraFilesystem * | fs,
|  | const char * | filename,
|  | char ** | folder,
|  | GPContext * | context
| ) |  |

Search a folder that contains a given filename.

Parameters

  fs | a CameraFilesystem
  filename | the name of the file to search in the fs
  folder | pointer to value where the string is stored in
  context | a GPContext

Searches a file called filename in the fs and returns the first occurrency. This functionality is needed for camera drivers that cannot figure out where a file gets created after capturing an image although the name of the image is known. Usually, those drivers will call gp_filesystem_reset in order to tell the fs that something has changed and then gp_filesystem_get_folder in order to find the file.

Note that you get a reference to the string stored in the filesystem structure, so do not free it yourself.

Returns
  a gphoto2 error code.

## gp_filesystem_get_info()

int gp_filesystem_get_info | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | filename,
|  | CameraFileInfo * | info,
|  | GPContext * | context
| ) |  |

Get information about the specified file.

Parameters

  fs | a CameraFilesystem
  folder | the folder that contains the file
  filename | the filename
  info | pointer to CameraFileInfo that receives the information
  context | a GPContext

Returns
  a gphoto2 error code.

## gp_filesystem_get_storageinfo()

int gp_filesystem_get_storageinfo | ( | CameraFilesystem * | fs,
|  | CameraStorageInformation ** | storageinfo,
|  | int * | nrofstorageinfos,
|  | GPContext * | context
| ) |  |

Get the storage information about this filesystem.

Parameters

  fs | the filesystem
  storageinfo | Pointer to receive a pointer to/array of storage info items
  nrofstorageinfos | Pointer to receive number of array entries
  context | a GPContext

This function is only called from gp_camera_get_storageinfo(). You may want to make sure this information is consistent with the information on gp_camera_get_storageinfo().

Retrieves the storage information, like maximum and free space, for the specified filesystem, if supported by the device. The storage information is returned in an newly allocated array of CameraStorageInformation objects, to which the pointer pointed to by #storageinfo will be set.

The variable pointed to by #nrofstorageinfos will be set to the number of elements in that array.

It is the caller's responsibility to free the memory of the array.

Returns
  a gphoto error code

## gp_filesystem_list_files()

int gp_filesystem_list_files | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | CameraList * | list,
|  | GPContext * | context
| ) |  |

Get the list of files in a folder.

Parameters

  fs | a CameraFilesystem
  folder | a folder of which a file list should be generated
  list | a CameraList where to put the list of files into
  context | a GPContext

Lists the files in folder using either cached values or (if there aren't any) the file_list_func which (hopefully) has been previously supplied.

Returns
  a gphoto2 error code.

## gp_filesystem_list_folders()

int gp_filesystem_list_folders | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | CameraList * | list,
|  | GPContext * | context
| ) |  |

List all subfolders within a filesystem folder.

Parameters

  fs | a CameraFilesystem
  folder | a folder
  list | a CameraList where subfolders should be listed
  context | a GPContext

Generates a list of subfolders of the supplied folder either using cached values (if there are any) or the folder_list_func if it has been supplied previously. If not, it is assumed that only a root folder exists (which is the case for many cameras).

Returns
  a gphoto2 error code.

## gp_filesystem_make_dir()

int gp_filesystem_make_dir | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | name,
|  | GPContext * | context
| ) |  |

Create a subfolder within a folder.

Parameters

  fs | a CameraFilesystem
  folder | the folder in which the directory should be created
  name | the name of the directory to be created
  context | a GPContext

Creates a new directory called name in given folder.

Returns
  a gphoto2 error code

## gp_filesystem_name()

int gp_filesystem_name | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | int | filenumber,
|  | const char ** | filename,
|  | GPContext * | context
| ) |  |

Lookup the filename of an indexed file within a folder.

Parameters

  fs | a CameraFilesystem
  folder | the folder where to look up the file with the filenumber
  filenumber | the number of the file
  filename | pointer to a filename where the result is stored
  context | a GPContext

Looks up the filename of file with given filenumber in given folder. See gp_filesystem_number for exactly the opposite functionality.

Returns
  a gphoto2 error code.

## gp_filesystem_new()

int gp_filesystem_new | ( | CameraFilesystem ** | fs | ) |

Create a new filesystem struct.

Parameters

  fs | a pointer to a CameraFilesystem

Creates a new empty CameraFilesystem

Returns
  a gphoto2 error code.

References GP_ERROR_NO_MEMORY, and GP_OK.

## gp_filesystem_number()

int gp_filesystem_number | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | filename,
|  | GPContext * | context
| ) |  |

Get the index of a file in specified folder.

Parameters

  fs | a CameraFilesystem
  folder | the folder where to look for file called filename
  filename | the file to look for
  context | a GPContext

Looks for a file called filename in the given folder. See gp_filesystem_name for exactly the opposite functionality.

Returns
  a gphoto2 error code.

## gp_filesystem_put_file()

int gp_filesystem_put_file | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | filename,
|  | CameraFileType | type,
|  | CameraFile * | file,
|  | GPContext * | context
| ) |  |

Upload a file to a folder on the device filesystem.

Parameters

  fs | a CameraFilesystem
  folder | the folder where to put the file into
  file | the file
  context | a GPContext

Uploads a file to the camera if a put_file_func has been previously supplied to the fs. If the upload is successful, the file will get cached in the fs.

Returns
  a gphoto2 error code.

## gp_filesystem_read_file()

int gp_filesystem_read_file | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | filename,
|  | CameraFileType | type,
|  | uint64_t | offset,
|  | char * | buf,
|  | uint64_t * | size,
|  | GPContext * | context
| ) |  |

Get partial file data from the filesystem.

Parameters

  fs | a CameraFilesystem
  folder | the folder in which the file can be found
  filename | the name of the file to download
  type | the type of the file
  offset | the offset where the data starts
  buf | the targetbuffer where the data will be put
  size | the size to read and that was read into the buffer
  context | a GPContext

Downloads the file called filename from the folder using the read_file_func if such a function has been previously supplied. If the file has been previously downloaded, the file is retrieved from cache.

The file is read partially into the passed buffer. The read starts at offset on the device and goes for at most size bytes. Reading over the end of the file might give errors, so get the maximum file size via an info function before.

Returns
  a gphoto2 error code.

## gp_filesystem_remove_dir()

int gp_filesystem_remove_dir | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | name,
|  | GPContext * | context
| ) |  |

Remove a subfolder from within a folder.

Parameters

  fs | a CameraFilesystem
  folder | the folder in which the directory should be created
  name | the name of the directory to be created
  context | a GPContext

Removes a directory called name from the given folder.

Returns
  a gphoto2 error code

## gp_filesystem_reset()

int gp_filesystem_reset | ( | CameraFilesystem * | fs | ) |

Clear the filesystem.

Parameters

  fs | the filesystem to be cleared

Resets the filesystem. All cached information including the folder tree will get lost and will be queried again on demand.

Returns
  a gphoto2 error code.

Referenced by gp_camera_exit(), and gp_filesystem_free().

## gp_filesystem_set_file_noop()

int gp_filesystem_set_file_noop | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | filename,
|  | CameraFileType | type,
|  | CameraFile * | file,
|  | GPContext * | context
| ) |  |

Attach file content to a specified file.

Parameters

  fs | a CameraFilesystem
  folder | a folder in the filesystem
  file | a CameraFile
  context | a GPContext

Tells the fs about a file. Typically, camera drivers will call this function in case they get information about a file (i.e. preview) "for free" on gp_camera_capture() or gp_camera_folder_list_files().

Returns
  a gphoto2 error code.

## gp_filesystem_set_funcs()

int gp_filesystem_set_funcs | ( | CameraFilesystem * | fs,
|  | CameraFilesystemFuncs * | funcs,
|  | void * | data
| ) |  |

Set all filesystem related function pointers.

Parameters

  fs | a CameraFilesystem
  funcs | pointer to a struct of filesystem functions
  data | private data

Tells the filesystem which functions to call for camera/filesystem specific functions, like listing, retrieving, uploading files and so on.

Returns
  a gphoto2 error code.

References GP_OK.

Referenced by camera_init().

## gp_filesystem_set_info()

int gp_filesystem_set_info | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | filename,
|  | CameraFileInfo | info,
|  | GPContext * | context
| ) |  |

Set information about a file.

Parameters

  fs | a CameraFilesystem
  folder | foldername where the file resides
  filename | the files name
  info | the CameraFileInfo to set
  context | a GPContext

Sets information about a file in the camera.

Returns
  a gphoto2 error code.

## gp_filesystem_set_info_dirty()

int gp_filesystem_set_info_dirty | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | filename,
|  | GPContext * | context
| ) |  |

Mark the file info as dirty.

Parameters

  fs | a CameraFilesystem
  folder | the foldername
  filename | the filename
  context | a GPContext

Mark the file info as dirty, so that the next attempt to retrieve the file info will query the camera driver instead of possibly returning cached data.

Returns
  a gphoto2 error code

## gp_filesystem_set_info_noop()

int gp_filesystem_set_info_noop | ( | CameraFilesystem * | fs,
|  | const char * | folder,
|  | const char * | filename,
|  | CameraFileInfo | info,
|  | GPContext * | context
| ) |  |

Store the file information in the virtual fs.

Parameters

  fs | a CameraFilesystem
  folder | the foldername
  info | the CameraFileInfo to store
  context | a GPContext

In contrast to gp_filesystem_set_info, gp_filesystem_set_info_noop will only change the file information in the fs. Typically, camera drivers will use this function in case they get file information "for free" on gp_camera_capture or gp_camera_folder_list_files.

Returns
  a gphoto2 error code